config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for :users, controllers: {
    confirmations: "users/confirmations",
    omniauth_callbacks: "users/omniauth_callbacks",
    passwords: "users/passwords",
    registrations: "users/registrations",
    sessions: "users/sessions",
    unlocks: "users/unlocks"
  }

  root to: "home#index"

  resources :documents do
    resource :outline, only: %i[show], controller: "documents/outline"
  end
end

app/models/document.rb
# frozen_string_literal: true

class Document < ApplicationRecord
  has_many :users_documents
  has_many :users, through: :users_documents

  has_many :diffs

  accepts_nested_attributes_for :users_documents

  delegate :diff, to: :ydoc
  delegate :full_diff, to: :ydoc
  delegate :state, to: :ydoc
  delegate :sync, to: :ydoc

  Heading = Struct.new(:level, :title)

  def headers
    find_headers(element).map do |header|
      level = header.attributes["level"].to_i
      title = extract_text(header)

      Heading.new(level, title)
    end
  end

  private

  def element
    @element ||= ydoc.get_xml_element("default")
  end

  def ydoc
    @ydoc ||= begin
      doc = Y::Doc.new
      diffs.pluck(:diff).each { |diff| doc.sync(decode(diff)) }
      doc
    end
  end

  def decode(diff)
    diff.split(",").map(&:to_i)
  end

  def find_headers(element)
    node = element.first_child
    list = []

    loop do
      next unless node.instance_of?(Y::XMLElement)

      list << node if node.tag == "heading"

      node = node.next_sibling
      break if node.blank?
    end

    list
  end

  def extract_text(element)
    # node = element.first_child
    # text = []
    #
    # loop do
    #   next unless node.instance_of?(Y::XMLText)
    #
    #   text << node.to_s
    #
    #   node = node.next_sibling
    #   break if node.blank?
    # end
    #
    # text.join
    element.first_child.to_s
  end
end

app/controllers/documents/outline_controller.rb
# frozen_string_literal: true

module Documents
  class OutlineController < ApplicationController
    before_action :set_document, only: %i[show]

    def show
    end

    private

    def set_document
      @document = Document.find(params[:document_id])
    end
  end
end

app/controllers/documents_controller.rb
# frozen_string_literal: true

class DocumentsController < ApplicationController
  before_action :set_document, only: %i[show edit update destroy]
  before_action :authenticate_user!

  layout "document"

  # GET /documents or /documents.json
  def index
    @documents = Document.all
  end

  # GET /documents/1 or /documents/1.json
  def show
  end

  # GET /documents/new
  def new
    @document = Document.new
  end

  # GET /documents/1/edit
  def edit
  end

  # POST /documents or /documents.json
  def create
    @document = Document.new(document_params)

    respond_to do |format|
      if @document.save
        current_user.documents << @document

        format.html do
          redirect_to document_url(@document),
                      notice: "Document was successfully created."
        end
        format.json { render :show, status: :created, location: @document }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json do
          render json: @document.errors, status: :unprocessable_entity
        end
      end
    end
  end

  # PATCH/PUT /documents/1 or /documents/1.json
  def update
    respond_to do |format|
      if @document.update(document_params)
        format.html do
          redirect_to document_url(@document),
                      notice: "Document was successfully updated."
        end
        format.json { render :show, status: :ok, location: @document }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json do
          render json: @document.errors, status: :unprocessable_entity
        end
      end
    end
  end

  # DELETE /documents/1 or /documents/1.json
  def destroy
    @document.destroy

    respond_to do |format|
      format.html do
        redirect_to documents_url,
                    notice: "Document was successfully destroyed."
      end
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_document
    @document = Document.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def document_params
    params.fetch(:document, {})
  end
end

app/helpers/documents/outlines_helper.rb
# frozen_string_literal: true

module Documents
  module OutlinesHelper
  end
end

app/helpers/documents_helper.rb
# frozen_string_literal: true

module DocumentsHelper
end

app/views/documents/_document.html.erb
<div id="<%= dom_id document %>">
  <% if action_name != "show" %>
    <%= link_to "Show this document", document, class: "rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
    <%= link_to 'Edit this document', edit_document_path(document), class: "rounded-lg py-3 ml-2 px-5 bg-gray-100 inline-block font-medium" %>
    <hr class="mt-6">
  <% end %>
</div>

app/views/documents/_form.html.erb
<div data-controller="document"
     data-document-id-value="<%= @document.id %>"
     class="flex justify-start p-4 pb-0 min-h-full overflow-y-scroll relative">
  <div class="shrink-0 w-56 ml-4 divide-y sticky top-0">
    <button class="text-gray-500 py-4">
      <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="2" stroke="currentColor" class="w-6 h-6">
        <path stroke-linecap="round" stroke-linejoin="round" d="M10.5 19.5L3 12m0 0l7.5-7.5M3 12h18"/>
      </svg>
    </button>
    <div class="py-4">
      <div class="text-gray-600 text-xs font-medium tracking-wide uppercase">Outline</div>
      <%= turbo_frame_tag dom_id(@document), src: document_outline_path(@document) %>
    </div>
  </div>
  <div class="shrink-0 w-[728px] p-24 pb-0 shadow-lg bg-white min-h-full h-max relative">
    <button data-document-target="rowMarker"
            type="button"
            class="absolute -right-4 top-2 w-8 h-8 rounded-full shadow flex justify-center inline-flex items-center rounded-full border border-transparent p-1 text-slate-400 hover:text-white bg-slate-50 hover:bg-purple-700 focus:outline-none">
      <svg class="h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
        <path d="M10.75 4.75a.75.75 0 00-1.5 0v4.5h-4.5a.75.75 0 000 1.5h4.5v4.5a.75.75 0 001.5 0v-4.5h4.5a.75.75 0 000-1.5h-4.5v-4.5z"/>
      </svg>
    </button>
    <div data-document-target="canvas" class="flex-none w-full"></div>
  </div>
</div>

app/views/documents/edit.html.erb
<div class="flex min-w-0 flex-1 flex-col overflow-hidden">
  <main class="flex flex-1 overflow-hidden">
    <div class="flex flex-1 flex-col overflow-y-auto xl:overflow-hidden">
      <!-- breadcrumbs -->
      <nav aria-label="Breadcrumb" class="border-b border-orange-gray-200 bg-white">
        <div class="mx-auto flex w-full items-start py-3 px-4 sm:px-6">
          <%= link_to root_path, class: "-ml-1 inline-flex items-center space-x-3 text-sm font-medium text-orange-gray-900" do %>
            <svg class="h-5 w-5 text-orange-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
              <path fill-rule="evenodd" d="M12.79 5.23a.75.75 0 01-.02 1.06L8.832 10l3.938 3.71a.75.75 0 11-1.04 1.08l-4.5-4.25a.75.75 0 010-1.08l4.5-4.25a.75.75 0 011.06.02z" clip-rule="evenodd"/>
            </svg>
            <span>Home</span>
          <% end %>
        </div>
      </nav>

      <nav aria-label="Breadcrumb" class="border-b border-orange-gray-200 bg-white">
        <div class="mx-auto flex w-full items-center py-1 px-4 sm:px-6 divide-x">
          <div class="mx-1">
            <button type="button" class="inline-flex items-center bg-white px-2 py-1 text-gray-700 rounded-sm hover:bg-gray-50 focus:outline-none focus:ring-1 focus:ring-orange-500 focus:ring-offset-1">
              <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-5 h-5">
                <path stroke-linecap="round" stroke-linejoin="round" d="M8.25 7.5V6.108c0-1.135.845-2.098 1.976-2.192.373-.03.748-.057 1.123-.08M15.75 18H18a2.25 2.25 0 002.25-2.25V6.108c0-1.135-.845-2.098-1.976-2.192a48.424 48.424 0 00-1.123-.08M15.75 18.75v-1.875a3.375 3.375 0 00-3.375-3.375h-1.5a1.125 1.125 0 01-1.125-1.125v-1.5A3.375 3.375 0 006.375 7.5H5.25m11.9-3.664A2.251 2.251 0 0015 2.25h-1.5a2.251 2.251 0 00-2.15 1.586m5.8 0c.065.21.1.433.1.664v.75h-6V4.5c0-.231.035-.454.1-.664M6.75 7.5H4.875c-.621 0-1.125.504-1.125 1.125v12c0 .621.504 1.125 1.125 1.125h9.75c.621 0 1.125-.504 1.125-1.125V16.5a9 9 0 00-9-9z"/>
              </svg>
            </button>
          </div>
          <div class="mx-1">
            <label id="listbox-label" class="block text-sm font-medium text-gray-700 sr-only">Heading</label>
            <div class="relative">
              <button type="button" class="relative w-full cursor-default rounded-sm bg-white py-1 pl-3 pr-10 text-left focus:border-orange-500 focus:outline-none focus:ring-1 focus:ring-orange-500 sm:text-sm" aria-haspopup="listbox" aria-expanded="true" aria-labelledby="listbox-label">
                <span class="block truncate">Normal text</span>
                <span class="pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2">
                  <svg class="h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
                    <path fill-rule="evenodd" d="M10 3a.75.75 0 01.55.24l3.25 3.5a.75.75 0 11-1.1 1.02L10 4.852 7.3 7.76a.75.75 0 01-1.1-1.02l3.25-3.5A.75.75 0 0110 3zm-3.76 9.2a.75.75 0 011.06.04l2.7 2.908 2.7-2.908a.75.75 0 111.1 1.02l-3.25 3.5a.75.75 0 01-1.1 0l-3.25-3.5a.75.75 0 01.04-1.06z" clip-rule="evenodd"/>
                  </svg>
                </span>
              </button>

              <!--              <ul class="absolute z-10 mt-1 bg-white py-1 w-56 text-base shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none sm:text-sm" tabindex="-1" role="listbox" aria-labelledby="listbox-label" aria-activedescendant="listbox-option-1">-->
              <!--                <li class="text-gray-900 relative cursor-default select-none py-2 pl-3 pr-9" id="listbox-option-0" role="option">-->
              <!--                  <span class="font-normal block truncate">Normal text</span>-->
              <!--                  <span class="text-orange-600 absolute inset-y-0 right-0 flex items-center pr-4">-->
              <!--                    <svg class="h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">-->
              <!--                      <path fill-rule="evenodd" d="M16.704 4.153a.75.75 0 01.143 1.052l-8 10.5a.75.75 0 01-1.127.075l-4.5-4.5a.75.75 0 011.06-1.06l3.894 3.893 7.48-9.817a.75.75 0 011.05-.143z" clip-rule="evenodd"/>-->
              <!--                    </svg>-->
              <!--                  </span>-->
              <!--                </li>-->
              <!--                <li class="text-gray-900 relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-1" role="option">-->
              <!--                  <span class="text-3xl font-bold block">Title</span>-->
              <!--                </li>-->
              <!--                <li class="text-gray-400 relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-2" role="option">-->
              <!--                  <span class="text-xl font-medium block">Subtitle</span>-->
              <!--                </li>-->
              <!--                <li class="text-black relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-2" role="option">-->
              <!--                  <span class="text-xl font-medium block">Heading 1</span>-->
              <!--                </li>-->
              <!--                <li class="text-black relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-2" role="option">-->
              <!--                  <span class="text-lg font-medium block">Heading 2</span>-->
              <!--                </li>-->
              <!--                <li class="text-black relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-2" role="option">-->
              <!--                  <span class="text-md font-medium block">Heading 3</span>-->
              <!--                </li>-->
              <!--              </ul>-->
            </div>
          </div>
          <div class="mx-1">
            <label id="select-font-family" class="block text-sm font-medium text-gray-700 sr-only">Font family</label>
            <div class="relative">
              <button type="button" class="relative w-full cursor-default rounded-sm bg-white py-1 pl-3 pr-10 text-left focus:border-orange-500 focus:outline-none focus:ring-1 focus:ring-orange-500 sm:text-sm" aria-haspopup="listbox" aria-expanded="true" aria-labelledby="select-font-family">
                <span class="block truncate">System font</span>
                <span class="pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2">
                  <svg class="h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
                    <path fill-rule="evenodd" d="M10 3a.75.75 0 01.55.24l3.25 3.5a.75.75 0 11-1.1 1.02L10 4.852 7.3 7.76a.75.75 0 01-1.1-1.02l3.25-3.5A.75.75 0 0110 3zm-3.76 9.2a.75.75 0 011.06.04l2.7 2.908 2.7-2.908a.75.75 0 111.1 1.02l-3.25 3.5a.75.75 0 01-1.1 0l-3.25-3.5a.75.75 0 01.04-1.06z" clip-rule="evenodd"/>
                  </svg>
                </span>
              </button>
            </div>
          </div>
          <div class="mx-1">
            <span class="isolate inline-flex">
              <button type="button" class="inline-flex items-center bg-white px-2 py-1 text-gray-700 rounded-sm hover:bg-gray-50 focus:outline-none focus:ring-1 focus:ring-orange-500 focus:ring-offset-1">
                <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-5 h-5">
                  <path stroke-linecap="round" stroke-linejoin="round" d="M3.75 6.75h16.5M3.75 12h16.5m-16.5 5.25H12"/>
                </svg>
              </button>

              <button type="button" class="inline-flex items-center bg-white px-2 py-1 text-gray-700 rounded-sm hover:bg-gray-50 focus:outline-none focus:ring-1 focus:ring-orange-500 focus:ring-offset-1">
                <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-5 h-5">
                  <path stroke-linecap="round" stroke-linejoin="round" d="M3.75 6.75h16.5M3.75 12h16.5M12 17.25h8.25" />
                </svg>
              </button>
              <button type="button" class="inline-flex items-center bg-white px-2 py-1 text-gray-700 rounded-sm hover:bg-gray-50 focus:outline-none focus:ring-1 focus:ring-orange-500 focus:ring-offset-1">
                <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-5 h-5">
                  <path stroke-linecap="round" stroke-linejoin="round" d="M3.75 5.25h16.5m-16.5 4.5h16.5m-16.5 4.5h16.5m-16.5 4.5h16.5" />
                </svg>
              </button>
            </span>
          </div>
        </div>
      </nav>
      <%= render "form", document: @document %>
    </div>
  </main>
</div>

app/views/documents/index.html.erb
<div class="w-full">
  <% if notice.present? %>
    <p class="py-2 px-3 bg-green-50 mb-5 text-green-500 font-medium rounded-lg inline-block" id="notice"><%= notice %></p>
  <% end %>

  <div class="flex justify-between items-center">
    <h1 class="font-bold text-4xl">Documents</h1>
    <%= link_to 'New document', new_document_path, class: "rounded-lg py-3 px-5 bg-blue-600 text-white block font-medium" %>
  </div>

  <div id="documents" class="min-w-full">
    <%= render @documents %>
  </div>
</div>

app/views/documents/new.html.erb
<div class="flex min-w-0 flex-1 flex-col overflow-hidden">
  <main class="flex flex-1 overflow-hidden">
    <div class="flex flex-1 flex-col overflow-y-auto xl:overflow-hidden">
      <!-- breadcrumbs -->
      <nav aria-label="Breadcrumb" class="border-b border-orange-gray-200 bg-white">
        <div class="mx-auto flex w-full items-start py-3 px-4 sm:px-6">
          <%= link_to root_path, class: "-ml-1 inline-flex items-center space-x-3 text-sm font-medium text-orange-gray-900" do %>
            <svg class="h-5 w-5 text-orange-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
              <path fill-rule="evenodd" d="M12.79 5.23a.75.75 0 01-.02 1.06L8.832 10l3.938 3.71a.75.75 0 11-1.04 1.08l-4.5-4.25a.75.75 0 010-1.08l4.5-4.25a.75.75 0 011.06.02z" clip-rule="evenodd"/>
            </svg>
            <span>Home</span>
          <% end %>
        </div>
      </nav>
      <nav aria-label="Breadcrumb" class="border-b border-orange-gray-200 bg-white">
        <div class="mx-auto flex w-full items-center py-1 px-4 sm:px-6 divide-x">
          <div class="mx-1">
            <button type="button" class="inline-flex items-center bg-white px-2 py-1 text-gray-700 rounded-sm hover:bg-gray-50 focus:outline-none focus:ring-1 focus:ring-orange-500 focus:ring-offset-1">
              <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-5 h-5">
                <path stroke-linecap="round" stroke-linejoin="round" d="M8.25 7.5V6.108c0-1.135.845-2.098 1.976-2.192.373-.03.748-.057 1.123-.08M15.75 18H18a2.25 2.25 0 002.25-2.25V6.108c0-1.135-.845-2.098-1.976-2.192a48.424 48.424 0 00-1.123-.08M15.75 18.75v-1.875a3.375 3.375 0 00-3.375-3.375h-1.5a1.125 1.125 0 01-1.125-1.125v-1.5A3.375 3.375 0 006.375 7.5H5.25m11.9-3.664A2.251 2.251 0 0015 2.25h-1.5a2.251 2.251 0 00-2.15 1.586m5.8 0c.065.21.1.433.1.664v.75h-6V4.5c0-.231.035-.454.1-.664M6.75 7.5H4.875c-.621 0-1.125.504-1.125 1.125v12c0 .621.504 1.125 1.125 1.125h9.75c.621 0 1.125-.504 1.125-1.125V16.5a9 9 0 00-9-9z"/>
              </svg>
            </button>
          </div>
          <div class="mx-1">
            <label id="listbox-label" class="block text-sm font-medium text-gray-700 sr-only">Heading</label>
            <div class="relative">
              <button type="button" class="relative w-full cursor-default rounded-sm bg-white py-1 pl-3 pr-10 text-left focus:border-orange-500 focus:outline-none focus:ring-1 focus:ring-orange-500 sm:text-sm" aria-haspopup="listbox" aria-expanded="true" aria-labelledby="listbox-label">
                <span class="block truncate">Normal text</span>
                <span class="pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2">
                  <svg class="h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
                    <path fill-rule="evenodd" d="M10 3a.75.75 0 01.55.24l3.25 3.5a.75.75 0 11-1.1 1.02L10 4.852 7.3 7.76a.75.75 0 01-1.1-1.02l3.25-3.5A.75.75 0 0110 3zm-3.76 9.2a.75.75 0 011.06.04l2.7 2.908 2.7-2.908a.75.75 0 111.1 1.02l-3.25 3.5a.75.75 0 01-1.1 0l-3.25-3.5a.75.75 0 01.04-1.06z" clip-rule="evenodd"/>
                  </svg>
                </span>
              </button>

<!--              <ul class="absolute z-10 mt-1 bg-white py-1 w-56 text-base shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none sm:text-sm" tabindex="-1" role="listbox" aria-labelledby="listbox-label" aria-activedescendant="listbox-option-1">-->
<!--                <li class="text-gray-900 relative cursor-default select-none py-2 pl-3 pr-9" id="listbox-option-0" role="option">-->
<!--                  <span class="font-normal block truncate">Normal text</span>-->
<!--                  <span class="text-orange-600 absolute inset-y-0 right-0 flex items-center pr-4">-->
<!--                    <svg class="h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">-->
<!--                      <path fill-rule="evenodd" d="M16.704 4.153a.75.75 0 01.143 1.052l-8 10.5a.75.75 0 01-1.127.075l-4.5-4.5a.75.75 0 011.06-1.06l3.894 3.893 7.48-9.817a.75.75 0 011.05-.143z" clip-rule="evenodd"/>-->
<!--                    </svg>-->
<!--                  </span>-->
<!--                </li>-->
<!--                <li class="text-gray-900 relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-1" role="option">-->
<!--                  <span class="text-3xl font-bold block">Title</span>-->
<!--                </li>-->
<!--                <li class="text-gray-400 relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-2" role="option">-->
<!--                  <span class="text-xl font-medium block">Subtitle</span>-->
<!--                </li>-->
<!--                <li class="text-black relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-2" role="option">-->
<!--                  <span class="text-xl font-medium block">Heading 1</span>-->
<!--                </li>-->
<!--                <li class="text-black relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-2" role="option">-->
<!--                  <span class="text-lg font-medium block">Heading 2</span>-->
<!--                </li>-->
<!--                <li class="text-black relative cursor-default py-2 pl-3 pr-9 hover:bg-slate-100" id="listbox-option-2" role="option">-->
<!--                  <span class="text-md font-medium block">Heading 3</span>-->
<!--                </li>-->
<!--              </ul>-->
            </div>
          </div>
          <div class="mx-1">
            <label id="select-font-family" class="block text-sm font-medium text-gray-700 sr-only">Font family</label>
            <div class="relative">
              <button type="button" class="relative w-full cursor-default rounded-sm bg-white py-1 pl-3 pr-10 text-left focus:border-orange-500 focus:outline-none focus:ring-1 focus:ring-orange-500 sm:text-sm" aria-haspopup="listbox" aria-expanded="true" aria-labelledby="select-font-family">
                <span class="block truncate">System font</span>
                <span class="pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2">
                  <svg class="h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
                    <path fill-rule="evenodd" d="M10 3a.75.75 0 01.55.24l3.25 3.5a.75.75 0 11-1.1 1.02L10 4.852 7.3 7.76a.75.75 0 01-1.1-1.02l3.25-3.5A.75.75 0 0110 3zm-3.76 9.2a.75.75 0 011.06.04l2.7 2.908 2.7-2.908a.75.75 0 111.1 1.02l-3.25 3.5a.75.75 0 01-1.1 0l-3.25-3.5a.75.75 0 01.04-1.06z" clip-rule="evenodd"/>
                  </svg>
                </span>
              </button>
            </div>
          </div>
          <div class="mx-1">
            <span class="isolate inline-flex">
              <button type="button" class="inline-flex items-center bg-white px-2 py-1 text-gray-700 rounded-sm hover:bg-gray-50 focus:outline-none focus:ring-1 focus:ring-orange-500 focus:ring-offset-1">
                <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-5 h-5">
                  <path stroke-linecap="round" stroke-linejoin="round" d="M3.75 6.75h16.5M3.75 12h16.5m-16.5 5.25H12"/>
                </svg>
              </button>

              <button type="button" class="inline-flex items-center bg-white px-2 py-1 text-gray-700 rounded-sm hover:bg-gray-50 focus:outline-none focus:ring-1 focus:ring-orange-500 focus:ring-offset-1">
                <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-5 h-5">
                  <path stroke-linecap="round" stroke-linejoin="round" d="M3.75 6.75h16.5M3.75 12h16.5M12 17.25h8.25" />
                </svg>
              </button>
              <button type="button" class="inline-flex items-center bg-white px-2 py-1 text-gray-700 rounded-sm hover:bg-gray-50 focus:outline-none focus:ring-1 focus:ring-orange-500 focus:ring-offset-1">
                <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-5 h-5">
                  <path stroke-linecap="round" stroke-linejoin="round" d="M3.75 5.25h16.5m-16.5 4.5h16.5m-16.5 4.5h16.5m-16.5 4.5h16.5" />
                </svg>
              </button>
            </span>
          </div>
        </div>
      </nav>
      <%= render "form", document: @document %>
    </div>
  </main>
</div>